{-# OPTIONS -fglasgow-exts -cpp #-}
-- parser produced by Happy Version 1.14

{-
Part of "Haski the Robot"
examination project for adv. funct. progr. 2004

    Copyright (C) 2004  Lars Otten

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

-}

{-

  I M P O R T A N T  ! ! !
----------------------------
after creating the parser with happy make the following change
at the end of the definition of
"happyNewToken action sts stk (tk:tks)":
Change the line
	_ -> happyError tks
to
	_ -> happyError (tk:tks)

-}

module HaskiParser(
		haskiParser,	-- the actual parsing function
		Program(..),	-- the datatype for the commands
		Function(..),	-- represents a function definition
		Sensor(..),	-- contains the sensors of the robot
		LexE(..)	-- Monad for handling errors in parsing
		) where

import HaskiLexer
import ErrorMonad
import Array
#if __GLASGOW_HASKELL__ >= 503
import GHC.Exts
#else
import GlaExts
#endif

newtype HappyAbsSyn  = HappyAbsSyn (() -> ())
happyIn4 :: ([Function]) -> (HappyAbsSyn )
happyIn4 x = unsafeCoerce# x
{-# INLINE happyIn4 #-}
happyOut4 :: (HappyAbsSyn ) -> ([Function])
happyOut4 x = unsafeCoerce# x
{-# INLINE happyOut4 #-}
happyIn5 :: (Program) -> (HappyAbsSyn )
happyIn5 x = unsafeCoerce# x
{-# INLINE happyIn5 #-}
happyOut5 :: (HappyAbsSyn ) -> (Program)
happyOut5 x = unsafeCoerce# x
{-# INLINE happyOut5 #-}
happyIn6 :: (Program) -> (HappyAbsSyn )
happyIn6 x = unsafeCoerce# x
{-# INLINE happyIn6 #-}
happyOut6 :: (HappyAbsSyn ) -> (Program)
happyOut6 x = unsafeCoerce# x
{-# INLINE happyOut6 #-}
happyIn7 :: (Sensor) -> (HappyAbsSyn )
happyIn7 x = unsafeCoerce# x
{-# INLINE happyIn7 #-}
happyOut7 :: (HappyAbsSyn ) -> (Sensor)
happyOut7 x = unsafeCoerce# x
{-# INLINE happyOut7 #-}
happyIn8 :: (Sensor) -> (HappyAbsSyn )
happyIn8 x = unsafeCoerce# x
{-# INLINE happyIn8 #-}
happyOut8 :: (HappyAbsSyn ) -> (Sensor)
happyOut8 x = unsafeCoerce# x
{-# INLINE happyOut8 #-}
happyIn9 :: (Sensor) -> (HappyAbsSyn )
happyIn9 x = unsafeCoerce# x
{-# INLINE happyIn9 #-}
happyOut9 :: (HappyAbsSyn ) -> (Sensor)
happyOut9 x = unsafeCoerce# x
{-# INLINE happyOut9 #-}
happyInTok :: Token -> (HappyAbsSyn )
happyInTok x = unsafeCoerce# x
{-# INLINE happyInTok #-}
happyOutTok :: (HappyAbsSyn ) -> Token
happyOutTok x = unsafeCoerce# x
{-# INLINE happyOutTok #-}

happyActOffsets :: HappyAddr
happyActOffsets = HappyA# "\xc9\x00\xc9\x00\xe1\x00\xc2\x00\xbf\x00\x6c\x00\xdf\x00\x00\x00\x6c\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x77\x00\x77\x00\x77\x00\x61\x00\x00\x00\x56\x00\xdf\x00\x77\x00\x56\x00\x4b\x00\x00\x00\x99\x00\x80\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x40\x00\x35\x00\xbd\x00\x2a\x00\x00\x00\x00\x00\x00\x00\x2a\x00\x00\x00\x2a\x00\x00\x00\x99\x00\x98\x00\x00\x00\x77\x00\x1f\x00\x14\x00\xba\x00\x00\x00\x77\x00\xb9\x00\x00\x00\x14\x00\x00\x00\x00\x00\x99\x00\x99\x00\x96\x00\xb6\x00\xb5\x00\x00\x00\x00\x00\x00\x00\x8d\x00\x00\x00\xb2\x00\x09\x00\x00\x00\x00\x00\xfe\xff\x00\x00\xb1\x00\x00\x00\x00\x00"#

happyGotoOffsets :: HappyAddr
happyGotoOffsets = HappyA# "\xe0\x00\x00\x00\x00\x00\x00\x00\x00\x00\xd9\x00\x00\x00\x00\x00\xd7\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x9e\x00\x9b\x00\x9a\x00\xdd\x00\x00\x00\xd5\x00\x00\x00\x7d\x00\xd3\x00\xdc\x00\x00\x00\xce\x00\xfd\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xa6\x00\xa0\x00\x00\x00\xcf\x00\x00\x00\x00\x00\x00\x00\xcd\x00\x00\x00\xcb\x00\x00\x00\xc6\x00\x00\x00\x00\x00\x7a\x00\x7f\x00\xc7\x00\x00\x00\x00\x00\x79\x00\x00\x00\x00\x00\xc5\x00\x00\x00\x00\x00\xc0\x00\xbe\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x0b\x00\x00\x00\x00\x00\x83\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyDefActions :: HappyAddr
happyDefActions = HappyA# "\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xfe\xff\xfc\xff\x00\x00\xf9\xff\xf8\xff\xf7\xff\xf6\xff\xf5\xff\x00\x00\x00\x00\x00\x00\x00\x00\xea\xff\x00\x00\xfd\xff\x00\x00\x00\x00\x00\x00\xe9\xff\x00\x00\x00\x00\xe1\xff\xe0\xff\xdf\xff\xde\xff\xdd\xff\xdc\xff\xdb\xff\xda\xff\xd9\xff\x00\x00\x00\x00\x00\x00\x00\x00\xfa\xff\xfb\xff\xf4\xff\x00\x00\xf0\xff\x00\x00\xe8\xff\x00\x00\x00\x00\xe2\xff\x00\x00\x00\x00\x00\x00\x00\x00\xf2\xff\x00\x00\x00\x00\xee\xff\x00\x00\xe3\xff\xe6\xff\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\xf3\xff\xef\xff\xe7\xff\xe4\xff\xe5\xff\x00\x00\x00\x00\xf1\xff\xec\xff\x00\x00\xed\xff\x00\x00\xeb\xff"#

happyCheck :: HappyAddr
happyCheck = HappyA# "\xff\xff\x03\x00\x05\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x03\x00\x02\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x03\x00\x1a\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x03\x00\x1a\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x03\x00\x1a\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x03\x00\x1a\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x03\x00\x1a\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x03\x00\x1a\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x03\x00\x1a\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x03\x00\x1a\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x03\x00\x1a\x00\x05\x00\x06\x00\x07\x00\x08\x00\x09\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x03\x00\x1a\x00\x03\x00\x03\x00\x05\x00\x05\x00\x03\x00\x02\x00\x05\x00\x03\x00\x01\x00\x02\x00\x1a\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x04\x00\x0e\x00\x04\x00\x03\x00\x03\x00\x05\x00\x05\x00\x03\x00\x02\x00\x05\x00\x0e\x00\x0f\x00\x0e\x00\x0f\x00\x02\x00\x10\x00\x11\x00\x12\x00\x13\x00\x14\x00\x15\x00\x16\x00\x17\x00\x18\x00\x19\x00\x02\x00\x02\x00\x04\x00\x04\x00\x02\x00\x02\x00\x04\x00\x04\x00\x02\x00\x02\x00\x04\x00\x04\x00\x02\x00\x01\x00\x04\x00\x04\x00\x05\x00\x04\x00\x05\x00\x01\x00\x02\x00\x01\x00\x02\x00\x04\x00\x05\x00\x01\x00\x02\x00\x01\x00\x02\x00\x01\x00\x02\x00\x04\x00\x05\x00\x01\x00\x02\x00\x01\x00\x02\x00\x01\x00\x02\x00\x01\x00\x02\x00\x1a\x00\x1b\x00\x02\x00\x02\x00\x00\x00\x02\x00\x01\x00\x1a\x00\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff\xff"#

happyTable :: HappyAddr
happyTable = HappyA# "\x00\x00\x09\x00\x2e\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x4c\x00\x4a\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x09\x00\x13\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x3b\x00\x13\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x09\x00\x13\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x2c\x00\x13\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x2e\x00\x13\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x35\x00\x13\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x09\x00\x13\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x17\x00\x13\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x09\x00\x13\x00\x0a\x00\x0b\x00\x0c\x00\x0d\x00\x0e\x00\x0f\x00\x10\x00\x11\x00\x12\x00\x1a\x00\x13\x00\x49\x00\x3b\x00\x18\x00\x18\x00\x36\x00\x39\x00\x18\x00\x30\x00\x4d\x00\x07\x00\x13\x00\x1b\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x24\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x24\x00\x45\x00\x3e\x00\x3d\x00\x17\x00\x24\x00\x18\x00\x18\x00\x25\x00\x2a\x00\x18\x00\x3e\x00\x3f\x00\x3e\x00\x3f\x00\x2c\x00\x33\x00\x1c\x00\x1d\x00\x1e\x00\x1f\x00\x20\x00\x21\x00\x22\x00\x23\x00\x24\x00\x28\x00\x28\x00\x4f\x00\x4d\x00\x28\x00\x28\x00\x43\x00\x44\x00\x28\x00\x28\x00\x49\x00\x38\x00\x28\x00\x14\x00\x2a\x00\x45\x00\x31\x00\x46\x00\x31\x00\x47\x00\x07\x00\x38\x00\x07\x00\x3f\x00\x31\x00\x40\x00\x07\x00\x41\x00\x07\x00\x28\x00\x07\x00\x30\x00\x31\x00\x35\x00\x07\x00\x14\x00\x07\x00\x26\x00\x07\x00\x06\x00\x07\x00\x05\x00\xff\xff\x33\x00\x15\x00\x03\x00\x28\x00\x06\x00\x03\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00"#

happyReduceArr = array (1, 38) [
	(1 , happyReduce_1),
	(2 , happyReduce_2),
	(3 , happyReduce_3),
	(4 , happyReduce_4),
	(5 , happyReduce_5),
	(6 , happyReduce_6),
	(7 , happyReduce_7),
	(8 , happyReduce_8),
	(9 , happyReduce_9),
	(10 , happyReduce_10),
	(11 , happyReduce_11),
	(12 , happyReduce_12),
	(13 , happyReduce_13),
	(14 , happyReduce_14),
	(15 , happyReduce_15),
	(16 , happyReduce_16),
	(17 , happyReduce_17),
	(18 , happyReduce_18),
	(19 , happyReduce_19),
	(20 , happyReduce_20),
	(21 , happyReduce_21),
	(22 , happyReduce_22),
	(23 , happyReduce_23),
	(24 , happyReduce_24),
	(25 , happyReduce_25),
	(26 , happyReduce_26),
	(27 , happyReduce_27),
	(28 , happyReduce_28),
	(29 , happyReduce_29),
	(30 , happyReduce_30),
	(31 , happyReduce_31),
	(32 , happyReduce_32),
	(33 , happyReduce_33),
	(34 , happyReduce_34),
	(35 , happyReduce_35),
	(36 , happyReduce_36),
	(37 , happyReduce_37),
	(38 , happyReduce_38)
	]

happy_n_terms = 28 :: Int
happy_n_nonterms = 6 :: Int

happyReduce_1 = happySpecReduce_3 0# happyReduction_1
happyReduction_1 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOutTok happy_x_1 of { (T _ _ (TName happy_var_1)) -> 
	case happyOut5 happy_x_3 of { happy_var_3 -> 
	happyIn4
		 ([Def happy_var_1 happy_var_3]
	)}}

happyReduce_2 = happyReduce 4# 0# happyReduction_2
happyReduction_2 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut4 happy_x_1 of { happy_var_1 -> 
	case happyOutTok happy_x_2 of { (T _ _ (TName happy_var_2)) -> 
	case happyOut5 happy_x_4 of { happy_var_4 -> 
	happyIn4
		 ((Def happy_var_2 happy_var_4) : happy_var_1
	) `HappyStk` happyRest}}}

happyReduce_3 = happySpecReduce_1 1# happyReduction_3
happyReduction_3 happy_x_1
	 =  case happyOut6 happy_x_1 of { happy_var_1 -> 
	happyIn5
		 (happy_var_1
	)}

happyReduce_4 = happySpecReduce_3 1# happyReduction_4
happyReduction_4 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut5 happy_x_2 of { happy_var_2 -> 
	happyIn5
		 (happy_var_2
	)}

happyReduce_5 = happySpecReduce_3 1# happyReduction_5
happyReduction_5 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut5 happy_x_1 of { happy_var_1 -> 
	case happyOut5 happy_x_3 of { happy_var_3 -> 
	happyIn5
		 (Seq happy_var_1 happy_var_3
	)}}

happyReduce_6 = happySpecReduce_1 2# happyReduction_6
happyReduction_6 happy_x_1
	 =  happyIn6
		 (Forward
	)

happyReduce_7 = happySpecReduce_1 2# happyReduction_7
happyReduction_7 happy_x_1
	 =  happyIn6
		 (Turn
	)

happyReduce_8 = happySpecReduce_1 2# happyReduction_8
happyReduction_8 happy_x_1
	 =  happyIn6
		 (Take
	)

happyReduce_9 = happySpecReduce_1 2# happyReduction_9
happyReduction_9 happy_x_1
	 =  happyIn6
		 (Drop
	)

happyReduce_10 = happySpecReduce_1 2# happyReduction_10
happyReduction_10 happy_x_1
	 =  happyIn6
		 (Idle
	)

happyReduce_11 = happySpecReduce_3 2# happyReduction_11
happyReduction_11 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut7 happy_x_2 of { happy_var_2 -> 
	case happyOut6 happy_x_3 of { happy_var_3 -> 
	happyIn6
		 (While happy_var_2 happy_var_3
	)}}

happyReduce_12 = happyReduce 5# 2# happyReduction_12
happyReduction_12 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut7 happy_x_2 of { happy_var_2 -> 
	case happyOut5 happy_x_4 of { happy_var_4 -> 
	happyIn6
		 (While happy_var_2 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_13 = happySpecReduce_3 2# happyReduction_13
happyReduction_13 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut6 happy_x_2 of { happy_var_2 -> 
	case happyOut7 happy_x_3 of { happy_var_3 -> 
	happyIn6
		 (Seq happy_var_2 (While happy_var_3 happy_var_2)
	)}}

happyReduce_14 = happyReduce 5# 2# happyReduction_14
happyReduction_14 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut5 happy_x_3 of { happy_var_3 -> 
	case happyOut7 happy_x_5 of { happy_var_5 -> 
	happyIn6
		 (Seq happy_var_3 (While happy_var_5 happy_var_3)
	) `HappyStk` happyRest}}

happyReduce_15 = happySpecReduce_3 2# happyReduction_15
happyReduction_15 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut7 happy_x_2 of { happy_var_2 -> 
	case happyOut6 happy_x_3 of { happy_var_3 -> 
	happyIn6
		 (IfThen happy_var_2 happy_var_3
	)}}

happyReduce_16 = happyReduce 5# 2# happyReduction_16
happyReduction_16 (happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut7 happy_x_2 of { happy_var_2 -> 
	case happyOut5 happy_x_4 of { happy_var_4 -> 
	happyIn6
		 (IfThen happy_var_2 happy_var_4
	) `HappyStk` happyRest}}

happyReduce_17 = happyReduce 4# 2# happyReduction_17
happyReduction_17 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut7 happy_x_2 of { happy_var_2 -> 
	case happyOut6 happy_x_3 of { happy_var_3 -> 
	case happyOut6 happy_x_4 of { happy_var_4 -> 
	happyIn6
		 (IfThenElse happy_var_2 happy_var_3 happy_var_4
	) `HappyStk` happyRest}}}

happyReduce_18 = happyReduce 6# 2# happyReduction_18
happyReduction_18 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut7 happy_x_2 of { happy_var_2 -> 
	case happyOut6 happy_x_3 of { happy_var_3 -> 
	case happyOut5 happy_x_5 of { happy_var_5 -> 
	happyIn6
		 (IfThenElse happy_var_2 happy_var_3 happy_var_5
	) `HappyStk` happyRest}}}

happyReduce_19 = happyReduce 6# 2# happyReduction_19
happyReduction_19 (happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut7 happy_x_2 of { happy_var_2 -> 
	case happyOut5 happy_x_4 of { happy_var_4 -> 
	case happyOut6 happy_x_6 of { happy_var_6 -> 
	happyIn6
		 (IfThenElse happy_var_2 happy_var_4 happy_var_6
	) `HappyStk` happyRest}}}

happyReduce_20 = happyReduce 8# 2# happyReduction_20
happyReduction_20 (happy_x_8 `HappyStk`
	happy_x_7 `HappyStk`
	happy_x_6 `HappyStk`
	happy_x_5 `HappyStk`
	happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut7 happy_x_2 of { happy_var_2 -> 
	case happyOut5 happy_x_4 of { happy_var_4 -> 
	case happyOut5 happy_x_7 of { happy_var_7 -> 
	happyIn6
		 (IfThenElse happy_var_2 happy_var_4 happy_var_7
	) `HappyStk` happyRest}}}

happyReduce_21 = happySpecReduce_1 2# happyReduction_21
happyReduction_21 happy_x_1
	 =  case happyOutTok happy_x_1 of { (T _ _ (TName happy_var_1)) -> 
	happyIn6
		 (Call happy_var_1
	)}

happyReduce_22 = happySpecReduce_1 3# happyReduction_22
happyReduction_22 happy_x_1
	 =  case happyOut9 happy_x_1 of { happy_var_1 -> 
	happyIn7
		 (happy_var_1
	)}

happyReduce_23 = happySpecReduce_2 3# happyReduction_23
happyReduction_23 happy_x_2
	happy_x_1
	 =  case happyOut9 happy_x_2 of { happy_var_2 -> 
	happyIn7
		 (Not happy_var_2
	)}

happyReduce_24 = happyReduce 4# 3# happyReduction_24
happyReduction_24 (happy_x_4 `HappyStk`
	happy_x_3 `HappyStk`
	happy_x_2 `HappyStk`
	happy_x_1 `HappyStk`
	happyRest)
	 = case happyOut8 happy_x_3 of { happy_var_3 -> 
	happyIn7
		 (Not happy_var_3
	) `HappyStk` happyRest}

happyReduce_25 = happySpecReduce_3 3# happyReduction_25
happyReduction_25 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut8 happy_x_2 of { happy_var_2 -> 
	happyIn7
		 (happy_var_2
	)}

happyReduce_26 = happySpecReduce_3 4# happyReduction_26
happyReduction_26 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut8 happy_x_1 of { happy_var_1 -> 
	case happyOut8 happy_x_3 of { happy_var_3 -> 
	happyIn8
		 (happy_var_1 :& happy_var_3
	)}}

happyReduce_27 = happySpecReduce_3 4# happyReduction_27
happyReduction_27 happy_x_3
	happy_x_2
	happy_x_1
	 =  case happyOut8 happy_x_1 of { happy_var_1 -> 
	case happyOut8 happy_x_3 of { happy_var_3 -> 
	happyIn8
		 (happy_var_1 :| happy_var_3
	)}}

happyReduce_28 = happySpecReduce_2 4# happyReduction_28
happyReduction_28 happy_x_2
	happy_x_1
	 =  case happyOut7 happy_x_2 of { happy_var_2 -> 
	happyIn8
		 (Not happy_var_2
	)}

happyReduce_29 = happySpecReduce_1 4# happyReduction_29
happyReduction_29 happy_x_1
	 =  case happyOut9 happy_x_1 of { happy_var_1 -> 
	happyIn8
		 (happy_var_1
	)}

happyReduce_30 = happySpecReduce_1 5# happyReduction_30
happyReduction_30 happy_x_1
	 =  happyIn9
		 (Front_free
	)

happyReduce_31 = happySpecReduce_1 5# happyReduction_31
happyReduction_31 happy_x_1
	 =  happyIn9
		 (Right_free
	)

happyReduce_32 = happySpecReduce_1 5# happyReduction_32
happyReduction_32 happy_x_1
	 =  happyIn9
		 (Left_free
	)

happyReduce_33 = happySpecReduce_1 5# happyReduction_33
happyReduction_33 happy_x_1
	 =  happyIn9
		 (Is_carrying
	)

happyReduce_34 = happySpecReduce_1 5# happyReduction_34
happyReduction_34 happy_x_1
	 =  happyIn9
		 (Field_has_item
	)

happyReduce_35 = happySpecReduce_1 5# happyReduction_35
happyReduction_35 happy_x_1
	 =  happyIn9
		 (Facing_up
	)

happyReduce_36 = happySpecReduce_1 5# happyReduction_36
happyReduction_36 happy_x_1
	 =  happyIn9
		 (Facing_right
	)

happyReduce_37 = happySpecReduce_1 5# happyReduction_37
happyReduction_37 happy_x_1
	 =  happyIn9
		 (Facing_down
	)

happyReduce_38 = happySpecReduce_1 5# happyReduction_38
happyReduction_38 happy_x_1
	 =  happyIn9
		 (Facing_left
	)

happyNewToken action sts stk [] =
	happyDoAction 27# (error "reading EOF!") action sts stk []

happyNewToken action sts stk (tk:tks) =
	let cont i = happyDoAction i tk action sts stk tks in
	case tk of {
	T _ _ TDefine -> cont 1#;
	T _ _ TSeq -> cont 2#;
	T _ _ TBO -> cont 3#;
	T _ _ TBC -> cont 4#;
	T _ _ TGo_forward -> cont 5#;
	T _ _ TTurn_right -> cont 6#;
	T _ _ TTake_item -> cont 7#;
	T _ _ TDrop_item -> cont 8#;
	T _ _ TDo_nothing -> cont 9#;
	T _ _ TWhile -> cont 10#;
	T _ _ TIfThen -> cont 11#;
	T _ _ TIfThenElse -> cont 12#;
	T _ _ TDoWhile -> cont 13#;
	T _ _ TAND -> cont 14#;
	T _ _ TOR -> cont 15#;
	T _ _ TNOT -> cont 16#;
	T _ _ TFront_free -> cont 17#;
	T _ _ TRight_free -> cont 18#;
	T _ _ TLeft_free -> cont 19#;
	T _ _ TIs_carrying -> cont 20#;
	T _ _ TField_has_item -> cont 21#;
	T _ _ TFacing_up -> cont 22#;
	T _ _ TFacing_right -> cont 23#;
	T _ _ TFacing_down -> cont 24#;
	T _ _ TFacing_left -> cont 25#;
	T _ _ (TName happy_dollar_dollar) -> cont 26#;
	_ -> happyError (tk:tks)
	}

happyThen :: LexE a -> (a -> LexE b) -> LexE b
happyThen = (>>=)
happyReturn :: a -> LexE a
happyReturn = (return)
happyThen1 m k tks = (>>=) m (\a -> k a tks)
happyReturn1 = \a tks -> (return) a

parse tks = happyThen (happyParse 0# tks) (\x -> happyReturn (happyOut4 x))

happySeq = happyDontSeq

happyError :: [Token] -> LexE a
happyError ((T p s _):ts) = Failed ("Line " ++ getLineNo p
               ++ ": Parse error on string \"" ++ s ++ "\"")
  where getLineNo (AlexPn _ l _) = show l
happyError [] = Failed "Parse error on end of file"

-------------------------------------------
-- output data type

data Sensor
 = Front_free
 | Right_free
 | Left_free
 | Field_has_item
 | Is_carrying
 | Facing_up
 | Facing_right
 | Facing_down
 | Facing_left
 | Sensor :& Sensor -- AND
 | Sensor :| Sensor -- OR
 | Not Sensor       -- Negation

instance Show Sensor where
 show Front_free = "front_free"
 show Right_free = "Right_free"
 show Left_free = "Left_free"
 show Field_has_item = "field_has_item"
 show Is_carrying = "is_carrying"
 show Facing_up = "facing_up"
 show Facing_right = "facing_right"
 show Facing_down = "facing_down"
 show Facing_left = "facing_left"
 show (Not p) = "Not " ++ show p
 show (p :& q) = "(" ++ show p ++ " :& " ++ show q ++ ")"
 show (p :| q) = "(" ++ show p ++ " :| " ++ show q ++ ")"

type Main
 = [Function]

data Function
 = Def String Program
    deriving Show

data Program
 = IfThen Sensor Program
 | IfThenElse Sensor Program Program
 | While Sensor Program
 | Forward
 | Turn
 | Take
 | Drop
 | Idle
 | Seq Program Program
 | End
 | Call String
    deriving Show

-- main parsing function
haskiParser input = lexer input >>= parse
{-# LINE 1 "GenericTemplate.hs" #-}
-- $Id$













{-# LINE 27 "GenericTemplate.hs" #-}



data Happy_IntList = HappyCons Int# Happy_IntList






































infixr 9 `HappyStk`
data HappyStk a = HappyStk a (HappyStk a)

-----------------------------------------------------------------------------
-- starting the parse

happyParse start_state = happyNewToken start_state notHappyAtAll notHappyAtAll

-----------------------------------------------------------------------------
-- Accepting the parse

happyAccept j tk st sts (HappyStk ans _) = (happyTcHack j 
				                  (happyTcHack st))
					   (happyReturn1 ans)

-----------------------------------------------------------------------------
-- Arrays only: do the next action



happyDoAction i tk st
	= {- nothing -}


	  case action of
		0#		  -> {- nothing -}
				     happyFail i tk st
		-1# 	  -> {- nothing -}
				     happyAccept i tk st
		n | (n <# (0# :: Int#)) -> {- nothing -}

				     (happyReduceArr ! rule) i tk st
				     where rule = (I# ((negateInt# ((n +# (1# :: Int#))))))
		n		  -> {- nothing -}


				     happyShift new_state i tk st
				     where new_state = (n -# (1# :: Int#))
   where off    = indexShortOffAddr happyActOffsets st
	 off_i  = (off +# i)
	 check  = if (off_i >=# (0# :: Int#))
			then (indexShortOffAddr happyCheck off_i ==#  i)
			else False
 	 action | check     = indexShortOffAddr happyTable off_i
		| otherwise = indexShortOffAddr happyDefActions st











indexShortOffAddr (HappyA# arr) off =
#if __GLASGOW_HASKELL__ > 500
	narrow16Int# i
#elif __GLASGOW_HASKELL__ == 500
	intToInt16# i
#else
	(i `iShiftL#` 16#) `iShiftRA#` 16#
#endif
  where
#if __GLASGOW_HASKELL__ >= 503
	i = word2Int# ((high `uncheckedShiftL#` 8#) `or#` low)
#else
	i = word2Int# ((high `shiftL#` 8#) `or#` low)
#endif
	high = int2Word# (ord# (indexCharOffAddr# arr (off' +# 1#)))
	low  = int2Word# (ord# (indexCharOffAddr# arr off'))
	off' = off *# 2#





data HappyAddr = HappyA# Addr#




-----------------------------------------------------------------------------
-- HappyState data type (not arrays)

{-# LINE 165 "GenericTemplate.hs" #-}


-----------------------------------------------------------------------------
-- Shifting a token

happyShift new_state 0# tk st sts stk@(x `HappyStk` _) =
     let i = (case unsafeCoerce# x of { (I# (i)) -> i }) in
--     trace "shifting the error token" $
     happyDoAction i tk new_state (HappyCons (st) (sts)) (stk)

happyShift new_state i tk st sts stk =
     happyNewToken new_state (HappyCons (st) (sts)) ((happyInTok (tk))`HappyStk`stk)

-- happyReduce is specialised for the common cases.

happySpecReduce_0 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_0 nt fn j tk st@((action)) sts stk
     = happyGoto nt j tk st (HappyCons (st) (sts)) (fn `HappyStk` stk)

happySpecReduce_1 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_1 nt fn j tk _ sts@((HappyCons (st@(action)) (_))) (v1`HappyStk`stk')
     = let r = fn v1 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_2 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_2 nt fn j tk _ (HappyCons (_) (sts@((HappyCons (st@(action)) (_))))) (v1`HappyStk`v2`HappyStk`stk')
     = let r = fn v1 v2 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happySpecReduce_3 i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happySpecReduce_3 nt fn j tk _ (HappyCons (_) ((HappyCons (_) (sts@((HappyCons (st@(action)) (_))))))) (v1`HappyStk`v2`HappyStk`v3`HappyStk`stk')
     = let r = fn v1 v2 v3 in
       happySeq r (happyGoto nt j tk st sts (r `HappyStk` stk'))

happyReduce k i fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyReduce k nt fn j tk st sts stk
     = case happyDrop (k -# (1# :: Int#)) sts of
	 sts1@((HappyCons (st1@(action)) (_))) ->
        	let r = fn stk in  -- it doesn't hurt to always seq here...
       		happyDoSeq r (happyGoto nt j tk st1 sts1 r)

happyMonadReduce k nt fn 0# tk st sts stk
     = happyFail 0# tk st sts stk
happyMonadReduce k nt fn j tk st sts stk =
        happyThen1 (fn stk) (\r -> happyGoto nt j tk st1 sts1 (r `HappyStk` drop_stk))
       where sts1@((HappyCons (st1@(action)) (_))) = happyDrop k (HappyCons (st) (sts))
             drop_stk = happyDropStk k stk

happyDrop 0# l = l
happyDrop n (HappyCons (_) (t)) = happyDrop (n -# (1# :: Int#)) t

happyDropStk 0# l = l
happyDropStk n (x `HappyStk` xs) = happyDropStk (n -# (1#::Int#)) xs

-----------------------------------------------------------------------------
-- Moving to a new state after a reduction


happyGoto nt j tk st = 
   {- nothing -}
   happyDoAction j tk new_state
   where off    = indexShortOffAddr happyGotoOffsets st
	 off_i  = (off +# nt)
 	 new_state = indexShortOffAddr happyTable off_i




-----------------------------------------------------------------------------
-- Error recovery (0# is the error token)

-- parse error if we are in recovery and we fail again
happyFail  0# tk old_st _ stk =
--	trace "failing" $ 
    	happyError


{-  We don't need state discarding for our restricted implementation of
    "error".  In fact, it can cause some bogus parses, so I've disabled it
    for now --SDM

-- discard a state
happyFail  0# tk old_st (HappyCons ((action)) (sts)) 
						(saved_tok `HappyStk` _ `HappyStk` stk) =
--	trace ("discarding state, depth " ++ show (length stk))  $
	happyDoAction 0# tk action sts ((saved_tok`HappyStk`stk))
-}

-- Enter error recovery: generate an error token,
--                       save the old token and carry on.
happyFail  i tk (action) sts stk =
--      trace "entering error recovery" $
	happyDoAction 0# tk action sts ( (unsafeCoerce# (I# (i))) `HappyStk` stk)

-- Internal happy errors:

notHappyAtAll = error "Internal Happy error\n"

-----------------------------------------------------------------------------
-- Hack to get the typechecker to accept our action functions


happyTcHack :: Int# -> a -> a
happyTcHack x y = y
{-# INLINE happyTcHack #-}


-----------------------------------------------------------------------------
-- Seq-ing.  If the --strict flag is given, then Happy emits 
--	happySeq = happyDoSeq
-- otherwise it emits
-- 	happySeq = happyDontSeq

happyDoSeq, happyDontSeq :: a -> b -> b
happyDoSeq   a b = a `seq` b
happyDontSeq a b = b

-----------------------------------------------------------------------------
-- Don't inline any functions from the template.  GHC has a nasty habit
-- of deciding to inline happyGoto everywhere, which increases the size of
-- the generated parser quite a bit.


{-# NOINLINE happyDoAction #-}
{-# NOINLINE happyTable #-}
{-# NOINLINE happyCheck #-}
{-# NOINLINE happyActOffsets #-}
{-# NOINLINE happyGotoOffsets #-}
{-# NOINLINE happyDefActions #-}

{-# NOINLINE happyShift #-}
{-# NOINLINE happySpecReduce_0 #-}
{-# NOINLINE happySpecReduce_1 #-}
{-# NOINLINE happySpecReduce_2 #-}
{-# NOINLINE happySpecReduce_3 #-}
{-# NOINLINE happyReduce #-}
{-# NOINLINE happyMonadReduce #-}
{-# NOINLINE happyGoto #-}
{-# NOINLINE happyFail #-}

-- end of Happy Template.
